import numpy as np
import sys
import os
from multiprocessing import Pool
import pyximport; pyximport.install()
import specEmd as cy
import pickle as pk


indir=sys.argv[1]
#outdir=sys.argv[2]
n=int(sys.argv[2])
outdir=indir+'Spec'
os.mkdir(outdir)
def get_queries(indir): #get list of networks in indir
    queries=[]
    for root, dirs, filenames in os.walk(indir):
        for f in filenames:
            if not ".coun" in f: 
                queries.append(os.path.join(root, f))
    queries.sort()
    return queries
# In[3]:

def toM(K,queries,n_file): # write matrix K to file
    f = open(n_file,'w')
    f.write('\t')
    for i in range(len(queries)):
            f.write(str(queries[i])+'\t')
    f.write('\n')
    for i in range(len(queries)):
            f.write(str(queries[i])+'\t')
            for j in range(len(queries)):
                    f.write(str(round(K[i][j],6))+'\t')
            f.write('\n')
    f.close()    
    return 1
def SEMD(v):
    return [v[0],v[1],cy.optEMD(v[2],v[3])]
def KSANLP(indir,n): #compute NetEmd for normalised graph laplacian
    queries=get_queries(indir)
    s=[]
    for i in range(len(queries)):
	f=open(queries[i]+'.countNLP','rb')
	s.append(cy.RS(pk.load(f))) #unpickle and rescale distributions
	f.close()
    V=[[i,j,s[i],s[j]] for i in range(len(queries)) for j in range(i+1,len(queries))] 
    if __name__ == '__main__': #feed distributions to NetEmd 
        p = Pool(n)
        c=p.imap(SEMD,V)
        p.close()
        p.join()
    K=np.zeros((len(queries),len(queries))) # put NetEmd values in matrix and write to file
    for t in c:
	K[t[0]][t[1]]=t[2]
	K[t[1]][t[0]]=t[2]
    toM(K,queries,outdir+'/NLPEMD_'+indir) 
    return K
def KSALP(indir,n): #compute NetEmd for graph laplacian
    queries=get_queries(indir)
    s=[]
    for i in range(len(queries)):
	f=open(queries[i]+'.countLP','rb')
	s.append(cy.RS(pk.load(f)))
	f.close()
    V=[[i,j,s[i],s[j]] for i in range(len(queries)) for j in range(i+1,len(queries))]
    if __name__ == '__main__':
        p = Pool(n)
        c=p.imap(SEMD,V)
        p.close()
        p.join()
    K=np.zeros((len(queries),len(queries)))
    for t in c:
	K[t[0]][t[1]]=t[2]
	K[t[1]][t[0]]=t[2]
    toM(K,queries,outdir+'/LPEMD_'+indir)
    return K   
    
    


# In[ ]:

mlp=KSALP(indir,n)
mnlp=KSANLP(indir,n)
M=(mlp+mnlp)/2.0 #combine NetEmd for graph laplacian and normalized graph laplacian
queries=get_queries(indir)
toM(M,queries,'NetEmd_spec_'+indir) # write to file

# In[ ]:



